-- =============================================================================
-- Sistema   : Comercial Comissaria
-- Data      : 31/01/2003
-- Criao   : Leonardo Monteiro
-- Obsjetivo : Gerar o relatrio de Faturamento por Vo/Perodo
-- =============================================================================
-- @C:\WIN_PRJ\SQL\END_CONV\ORACLE\1310_COCSTP_FormaPreco.sql
-- =============================================================================
-- dbms_output.put_line(V_DSFORMITFIMU);
-- SET SERVEROUTPUT ON
-- VAR P_RESULTADO VARCHAR2(80);
-- EXECUTE CALCULAMARKUP('001','001','006','',:P_RESULTADO)
-- =============================================================================
-- SET SERVEROUTPUT ON
-- VAR A VARCHAR2
-- EXECUTE CALCFORMAPRECO('9999','0007','0009','001','','120','0','0000006781','','12/03/2003','000000000999',:A);
-- =============================================================================
CREATE OR REPLACE PROCEDURE CALCFORMAPRECO(
P_CDFILIAL      IN FORMPRECOCIA.CDFILIAL    %TYPE,
P_CDCIA         IN FORMPRECOCIA.CDCIA       %TYPE,
P_CDMANCIA      IN MANUALCIA   .CDMANCIA    %TYPE,
P_CDMARKUP      IN ITFICHAFPRMU.CDMARKUP    %TYPE,
P_DSFORMULAMU   IN MARKUP      .DSFORMULAMU %TYPE,
P_TIPCUSTO      IN VARCHAR2,
P_CDSEQCUSSE    IN CUSTOSEMA   .CDSEQCUSSE  %TYPE,
P_CDLISTSERV    IN VARCHAR2,
P_DTCUSTOMA     IN CUSTOSEMA   .DTCUSTOMA   %TYPE,
P_CDOPERADOR    IN OPERADOR    .CDOPERADOR  %TYPE,
P_NRFORMPRECIA OUT FORMPRECOCIA.NRFORMPRECIA%TYPE,
P_NRTABPRECO   OUT TABPRECOSE.NRTABPRECO    %TYPE
)
AS
V_DSFORMULAMU  MARKUP     .DSFORMULAMU %TYPE;
V_DSFORMFICHMU FICHAFPRMU .DSFORMFICHMU%TYPE;
V_CDFICHAMP    PARGERALCOC.CDFICHAFPR  %TYPE; -- Cdigo da ficha de Matria-prima
V_SGFICHAMP    FICHAFPR   .SGFICHAFPR  %TYPE; -- Sigla da ficha de Matria-prima
V_NRFORMPRECIA NOVOCODIGO .NRSEQUENCIAL%TYPE;
V_CDFICHAFPR   PARGERALCOC.CDFICHAFPR  %TYPE;
V_NRSEQPRECO   NOVOCODIGO .NRSEQUENCIAL%TYPE;

V_SELECT_TEXT  VARCHAR2(1000);
C_INSFICHA     INTEGER;
C_INSSERVI     INTEGER;
V_RESULT       INTEGER;

V_NRTABPRECO   NOVOCODIGO.NRSEQUENCIAL%TYPE;
BEGIN
   NOVO_CODIGO_SC('TABELA/PRECO'||P_CDFILIAL||P_CDCIA,V_NRTABPRECO,1);
   V_NRTABPRECO := SUBSTR(V_NRTABPRECO,18,3);
   P_NRTABPRECO := V_NRTABPRECO;
   INSERT INTO TABPRECOSE
   (CDFILIAL,CDCIA,NRTABPRECO,NMTABPRECO,DTINIVIGTAB,
    DTFIMVIGTAB,DTINCTAB,CDOPERINCTAB)
   VALUES
   (P_CDFILIAL,P_CDCIA,V_NRTABPRECO,'Formao de Preo',TRUNC(SYSDATE),
    TRUNC(SYSDATE),TRUNC(SYSDATE),P_CDOPERADOR);

	IF TRIM(P_DSFORMULAMU) IS NULL THEN
      SELECT DSFORMULAMU
      INTO V_DSFORMULAMU
      FROM MARKUP
      WHERE (CDMARKUP = P_CDMARKUP);
   ELSE
   	V_DSFORMULAMU := P_DSFORMULAMU;
   END IF;

   /* Busca o cdigo da ficha de matria-prima */
	SELECT MAX(CDFICHAFPR)
   INTO V_CDFICHAMP
   FROM PARGERALCOC;

   IF V_CDFICHAMP IS NULL THEN
   	raise_application_error(-20502, 'No existe nenhuma ficha parametrizada para o preo da matria-prima.'||
                                      ' Favor parametriz-la na tela "Ambiente\Parmetros\Parmetros Gerais".', false);
   END IF;

   NOVO_CODIGO_SC('FORMPRECOCIA'||P_CDFILIAL,V_NRFORMPRECIA,1);
   V_NRFORMPRECIA := SUBSTR(V_NRFORMPRECIA,11,10);

   INSERT INTO FORMPRECOCIA
   (CDFILIAL,NRFORMPRECIA,CDMARKUP,CDCIA,NRTABPRECO)
   VALUES
   (P_CDFILIAL,V_NRFORMPRECIA,P_CDMARKUP,P_CDCIA,V_NRTABPRECO);

   FOR C_FICHA IN(SELECT FM.CDFICHAFPR,FI.SGFICHAFPR,FM.DSFORMFICHMU,FI.CDPICFICHFPR
                  FROM FICHAFPRMU FM, FICHAFPR FI
                  WHERE (FM.CDMARKUP    = P_CDMARKUP   ) AND
                        (FM.CDFICHAFPR <> V_CDFICHAMP  ) AND
                        (FI.CDFICHAFPR  = FM.CDFICHAFPR) AND
                        (INSTR(V_DSFORMULAMU,FI.SGFICHAFPR)>0)) LOOP

      V_CDFICHAFPR  := C_FICHA.CDFICHAFPR;

      /* Grava as fichas do Mark-up */
      INSERT INTO FICHFOPRECIA
      (CDFILIAL,NRFORMPRECIA,CDFICHAFPR)
      VALUES
      (P_CDFILIAL,V_NRFORMPRECIA,C_FICHA.CDFICHAFPR);

      RETORNA_ITEMFICHAMU('F',P_CDFILIAL,V_NRFORMPRECIA,P_CDMARKUP,C_FICHA.CDFICHAFPR,NULL,C_FICHA.DSFORMFICHMU,V_DSFORMFICHMU);

      /* Altera as fichas do Mark-up */
      V_SELECT_TEXT := '';
      V_SELECT_TEXT := V_SELECT_TEXT||' UPDATE FICHFOPRECIA';
      V_SELECT_TEXT := V_SELECT_TEXT||' SET DSFORMFOPCIA = NVL('||REPLACE(V_DSFORMFICHMU,',','.')||',0)';
      V_SELECT_TEXT := V_SELECT_TEXT||' WHERE (CDFILIAL     = '''||P_CDFILIAL        ||''') AND';
      V_SELECT_TEXT := V_SELECT_TEXT||'       (NRFORMPRECIA = '''||V_NRFORMPRECIA    ||''') AND';
      V_SELECT_TEXT := V_SELECT_TEXT||'       (CDFICHAFPR   = '''||C_FICHA.CDFICHAFPR||''')';

      /***********************************
         Converte os valores percentuais
       ***********************************/
		IF INSTR(C_FICHA.CDPICFICHFPR,'%')>0 THEN
      	V_DSFORMFICHMU := '(('||V_DSFORMFICHMU||')/100)';
      END IF;
      /***********************************/
   	V_DSFORMULAMU := REPLACE(V_DSFORMULAMU,C_FICHA.SGFICHAFPR,V_DSFORMFICHMU);

      C_INSFICHA := DBMS_SQL.OPEN_CURSOR;
      DBMS_SQL.PARSE(C_INSFICHA,V_SELECT_TEXT,DBMS_SQL.V7);

      V_RESULT := DBMS_SQL.EXECUTE(C_INSFICHA);
      DBMS_SQL.CLOSE_CURSOR(C_INSFICHA);

   END LOOP;

   /* Busca a sigla da ficha de matria-prima */
   SELECT MAX(SGFICHAFPR)
   INTO V_SGFICHAMP
   FROM FICHAFPR
   WHERE (CDFICHAFPR = V_CDFICHAMP);

   FOR C_SERV IN(SELECT CS.CDSERVICO,/*CS.CDCLASSE,CS.CDCICLO,*/
                        DECODE(P_TIPCUSTO,0,CS.VRCUSUNITMA,   /*Custo ltima Compra Lquido*/
                                          1,CS.VRCUSUNIT2MA,  /*Custo ltima Compra Bruto  */
                                          2,CS.VRCUSUNITMA1,  /*Custo Mdio Lquido        */
                                          3,CS.VRCUSUNI2MA1)  /*Custo Mdio Bruto          */
                        AS VRCUSTO, SC.IDTIPMANUAL
                 FROM CUSTOSEMA CS, SERVICOCIA SC
                 WHERE (CS.CDFILIAL   = P_CDFILIAL  ) AND
                       (CS.CDCIA      = P_CDCIA     ) AND
                       (CS.CDMANCIA   = P_CDMANCIA  ) AND
                       (INSTR(NVL(P_CDLISTSERV,'_'||CS.CDSERVICO/*||CS.CDCLASSE||CS.CDCICLO*/||'_'),
                              '_'||CS.CDSERVICO/*||CS.CDCLASSE||CS.CDCICLO*/||'_')>0) AND
                       (CS.DTCUSTOMA  = P_DTCUSTOMA ) AND
                       (CS.CDSEQCUSSE = P_CDSEQCUSSE) AND
                       (SC.CDCIA      = CS.CDCIA    ) AND
                       (SC.CDSERVICO  = CS.CDSERVICO)) LOOP

   	NOVO_CODIGO_SC('PRECOSERV'||P_CDFILIAL||P_CDCIA||V_NRTABPRECO||C_SERV.CDSERVICO,V_NRSEQPRECO,1);
      V_NRSEQPRECO := SUBSTR(V_NRSEQPRECO,11,10);

      V_SELECT_TEXT := '';
      V_SELECT_TEXT := V_SELECT_TEXT||' INSERT INTO PRECOSECIA';
      V_SELECT_TEXT := V_SELECT_TEXT||' (CDFILIAL,CDCIA,NRTABPRECO,CDSERVICO,';
      V_SELECT_TEXT := V_SELECT_TEXT||'  NRSEQPRECO,DTHRINCPRESE,CDOPERPRESE,NRFORMPRECIA,';
      IF C_SERV.IDTIPMANUAL = '1' THEN
      	V_SELECT_TEXT := V_SELECT_TEXT||' VRCUSTOSE ,VRPRESERV )';
      ELSE
      	V_SELECT_TEXT := V_SELECT_TEXT||' VRCUSTOSEE,VRPRESERVD)';
      END IF;
      V_SELECT_TEXT := V_SELECT_TEXT||' VALUES';
      V_SELECT_TEXT := V_SELECT_TEXT||' ('''||P_CDFILIAL||''','''||P_CDCIA||''','''||V_NRTABPRECO||''','''||C_SERV.CDSERVICO||''',';
      V_SELECT_TEXT := V_SELECT_TEXT||'  '''||V_NRSEQPRECO||''','''||SYSDATE||''','''||P_CDOPERADOR||''','''||V_NRFORMPRECIA||''',';
      V_SELECT_TEXT := V_SELECT_TEXT||' '||REPLACE(C_SERV.VRCUSTO,',','.')||',NVL('||REPLACE(REPLACE(V_DSFORMULAMU,V_SGFICHAMP,TO_CHAR(C_SERV.VRCUSTO)),',','.')||',0))';

      C_INSSERVI := DBMS_SQL.OPEN_CURSOR;
      DBMS_SQL.PARSE(C_INSSERVI,V_SELECT_TEXT,DBMS_SQL.V7);

      V_RESULT := DBMS_SQL.EXECUTE(C_INSSERVI);
      DBMS_SQL.CLOSE_CURSOR(C_INSSERVI);

   END LOOP;

   P_NRFORMPRECIA := V_NRFORMPRECIA;
EXCEPTION
	WHEN OTHERS THEN
   	IF DBMS_SQL.IS_OPEN(C_INSFICHA) THEN
   		DBMS_SQL.CLOSE_CURSOR(C_INSFICHA);
   		raise_application_error(-20502, 'No foi possvel calcular a frmula da ficha '||V_CDFICHAFPR||
                                         '. Verifique esta frmula e tente novamente.', false);

      ELSIF DBMS_SQL.IS_OPEN(C_INSSERVI) THEN
   		DBMS_SQL.CLOSE_CURSOR(C_INSSERVI);
   		raise_application_error(-20502, 'No foi possvel calcular a frmula do mark-up. '||
                                         'Verifique esta frmula e tente novamente.', false);

      ELSE
      	RAISE;
      END IF;
END;
/

