/* Sistemas Integrados TEKNISA
   Compras e Suprimentos

Nome: 8330_CMPSTPO.sql

Descrio:
Manuteno na coleta de preos via web.

Criao:
29/02/2000 Andr Luiz Bonente Barbosa
*/

CREATE OR REPLACE PROCEDURE PED_COL(
  P_CDFILIAL     IN FILIAL.CDFILIAL%TYPE,
  P_NRPEDCOLETA  IN PEDCOLETA.NRPEDCOLETA%TYPE,
  P_CDMARCA      IN MARCA.CDMARCA%TYPE,
  P_CDREGIAO     IN REGIAO.CDREGIAO%TYPE,
  P_CDPRODUTO    IN PRODUTO.CDPRODUTO%TYPE,
  P_CDFORNECED   IN FORNECEDOR.CDFORNECED%TYPE,
  P_NRCOLEPRECO  IN COLETAPR.NRCOLEPRECO%TYPE,
  P_DTINIVALCOL  IN COLETAPR.DTINIVALCOL%TYPE,
  P_DTFINVALCOL  IN COLETAPR.DTFINVALCOL%TYPE,
  P_DTINIVALITM  IN ITEMCOLE.DTINIVALITM%TYPE,
  P_DTFINVALITM  IN ITEMCOLE.DTFINVALITM%TYPE,
  P_VALOR        IN ITEMCOLE.VRPRECUNIITM%TYPE,
  P_NOVONRCOLPR  IN COLETAPR.NRCOLEPRECO%TYPE,
  P_NRPZOENTCOL  IN ITEMCOLE.NRPZOENTCOL%TYPE,
  P_IDTIPFREITM  IN ITEMCOLE.IDTIPFREITM%TYPE,
  P_CDTIPCOB     IN ITEMCOLE.CDTIPCOB%TYPE,
  P_VRPERDESITM  IN ITEMCOLE.VRPERDESITM%TYPE,
  P_CDFORMPGTO   IN ITEMCOLE.CDFORMPGTO%TYPE,
  P_IDTPFOPGTCOL IN ITEMCOLE.IDTPFOPGTCOL%TYPE,
  P_NRPARCPGTCOL IN ITEMCOLE.NRPARCPGTCOL%TYPE,
  P_NRDIAPGFXCOL IN ITEMCOLE.NRDIAPGFXCOL%TYPE,
  P_IDUTDIAPGCOL IN ITEMCOLE.IDUTDIAPGCOL%TYPE,
  P_NRDIAPGTCOL1 IN PZOPGTITMCOL.NRDIASPGTCOL%TYPE,
  P_NRDIAPGTCOL2 IN PZOPGTITMCOL.NRDIASPGTCOL%TYPE,
  P_NRDIAPGTCOL3 IN PZOPGTITMCOL.NRDIASPGTCOL%TYPE,
  P_NRDIAPGTCOL4 IN PZOPGTITMCOL.NRDIASPGTCOL%TYPE,
  P_NRDIAPGTCOL5 IN PZOPGTITMCOL.NRDIASPGTCOL%TYPE,
  P_VRPERPGTCOL1 IN PZOPGTITMCOL.VRPERCPGTCOL%TYPE,
  P_VRPERPGTCOL2 IN PZOPGTITMCOL.VRPERCPGTCOL%TYPE,
  P_VRPERPGTCOL3 IN PZOPGTITMCOL.VRPERCPGTCOL%TYPE,
  P_VRPERPGTCOL4 IN PZOPGTITMCOL.VRPERCPGTCOL%TYPE,
  P_VRPERPGTCOL5 IN PZOPGTITMCOL.VRPERCPGTCOL%TYPE
)AS
   V_CODIGO        PEDCOLETA.NRPEDCOLETA%TYPE;
   V_CDEMPRESA     EMPRESA.CDEMPRESA%TYPE;
   V_INSCESTA      INSCRESTAD.CDINSCESTA%TYPE;
   V_PRODFORN      PRODFORN.CDPRODUTO%TYPE;
   V_CDFORMPGTO    PRODFORN.CDFORMPGTO%TYPE;
   V_IDTPFORPGPRF  PRODFORN.IDTPFORPGPRF%TYPE;
   V_NRPARCPGTPRF  PRODFORN.NRPARCPGTPRF%TYPE;
   V_NRDIAPGFIPRF  PRODFORN.NRDIAPGFIPRF%TYPE;
   V_IDUTDIAPGPRF  PRODFORN.IDUTDIAPGPRF%TYPE;
   V_IDTIPCOLRE    COLETAPR.IDTIPCOLREG%TYPE;
   COUNTPRODFORN   NUMBER;
   COUNTEMIT       NUMBER;
   COUNTEMPR       NUMBER;
   V_IDTIPFREITM   ITEMCOLE.IDTIPFREITM%TYPE;
   V_CDTIPCOB      ITEMCOLE.CDTIPCOB%TYPE;
   V_PZOPGTITMCOL  NUMBER;
   V_CDARVPROD     PRODUTO.CDARVPROD%TYPE;
BEGIN
/*   SELECT NVL(MAX(IDTPFRETFORN),'0'), NVL(MAX(CDTIPCOB),'0')
   INTO   V_IDTIPFREITM, V_CDTIPCOB
   FROM   FORNECEDOR
   WHERE  CDFORNECED = P_CDFORNECED;

   IF P_IDTIPFREITM IS NULL THEN
      IF V_IDTIPFREITM = 0 THEN
         V_IDTIPFREITM := NULL;
      END IF;
   ELSE
      V_IDTIPFREITM := P_IDTIPFREITM;
   END IF;
   IF P_CDTIPCOB IS NULL THEN
      IF V_CDTIPCOB = 0 THEN
         V_CDTIPCOB := NULL;
      END IF;
   ELSE
      V_CDTIPCOB := P_CDTIPCOB;
   END IF;*/
   IF P_CDREGIAO <> '' THEN
      V_IDTIPCOLRE := 'G';
   ELSE
      V_IDTIPCOLRE := 'L';
   END IF;


   BEGIN
      V_CODIGO := P_NOVONRCOLPR;
      INSERT INTO COLETAPR
         (CDFILIAL,     NRCOLEPRECO,  DTCOLEPREC,
          DTINIVALCOL,  DTFINVALCOL,  CDOPERADOR,
          IDTIPCOLREG,  NRPEDCOLETA,  CDFORNECED)
       SELECT
          CDFILIAL,      V_CODIGO,      TO_DATE(SYSDATE, 'DD/MM/YYYY'),
          P_DTINIVALCOL, P_DTFINVALCOL, CDOPERADOR,
          V_IDTIPCOLRE,  NRPEDCOLETA,   CDFORNECED
       FROM
          PEDCOLETA
       WHERE
          CDFILIAL    = P_CDFILIAL AND
          CDFORNECED  = P_CDFORNECED AND
          NRPEDCOLETA = P_NRPEDCOLETA AND
          (NOT EXISTS(SELECT
                          CDFILIAL,    NRCOLEPRECO, DTCOLEPREC,
                          DTINIVALCOL, DTFINVALCOL, CDOPERADOR,
                          IDTIPCOLREG, NRPEDCOLETA, CDFORNECED
                       FROM
                          COLETAPR
                       WHERE
                          NRCOLEPRECO = V_CODIGO AND
                          CDFILIAL    = P_CDFILIAL AND
                          CDFORNECED  = P_CDFORNECED AND
                          NRPEDCOLETA = P_NRPEDCOLETA ));

   EXCEPTION
       WHEN DUP_VAL_ON_INDEX THEN BEGIN
          V_CODIGO := P_NRCOLEPRECO;
          UPDATE COLETAPR
          SET    DTINIVALCOL = P_DTINIVALCOL,
                 DTFINVALCOL = P_DTFINVALCOL
          WHERE  NRCOLEPRECO = V_CODIGO     AND
                 CDFORNECED  = P_CDFORNECED AND
                 CDFILIAL    = P_CDFILIAL;
       END;
   END;

   DELETE FROM PZOPGTITMCOL
   WHERE  CDFILIAL    = P_CDFILIAL    AND
          NRCOLEPRECO = V_CODIGO      AND
          CDFORNECED  = P_CDFORNECED  AND
          CDPRODUTO   = P_CDPRODUTO   AND
          CDMARCA     = P_CDMARCA     AND
          CDREGIAO    = P_CDREGIAO;

   BEGIN
      INSERT INTO ITEMCOLE
        (CDFILIAL,     NRCOLEPRECO,  CDFORNECED,    CDREGIAO,
         CDPRODUTO,    CDMARCA,      QTACMPITMCOL,  VRPRECUNIITM,
         DTINIVALITM,  DTFINVALITM,  NRPZOENTCOL,   IDTIPFREITM,
         CDTIPCOB,     VRPERDESITM,   CDFORMPGTO,
         IDTPFOPGTCOL, NRPARCPGTCOL, NRDIAPGFXCOL,  IDUTDIAPGCOL)
      (SELECT
         CDFILIAL,        V_CODIGO,       CDFORNECED,     CDREGIAO,
         CDPRODUTO,       CDMARCA,        QTPRODPEDCOL,   P_VALOR,
         P_DTINIVALITM,   P_DTFINVALITM,  P_NRPZOENTCOL,  P_IDTIPFREITM,
         P_CDTIPCOB,      P_VRPERDESITM,  P_CDFORMPGTO,
         P_IDTPFOPGTCOL,  P_NRPARCPGTCOL, P_NRDIAPGFXCOL, P_IDUTDIAPGCOL
       FROM
         ITEMPEDCOL
       WHERE
         ITEMPEDCOL.CDFILIAL    = P_CDFILIAL AND
         ITEMPEDCOL.CDFORNECED  = P_CDFORNECED AND
         ITEMPEDCOL.CDREGIAO    = P_CDREGIAO AND
         ITEMPEDCOL.CDPRODUTO   = P_CDPRODUTO AND
         ITEMPEDCOL.CDMARCA     = P_CDMARCA AND
         (NOT EXISTS(SELECT
                         CDFILIAL,  NRCOLEPRECO,  CDFORNECED,
                         CDREGIAO,  CDPRODUTO,    CDMARCA
                      FROM
                         ITEMCOLE
                      WHERE
                         CDFILIAL    = P_CDFILIAL AND
                         NRPEDCOLETA = P_NRPEDCOLETA AND
                         NRCOLEPRECO = V_CODIGO AND
                         CDFORNECED  = P_CDFORNECED AND
                         CDREGIAO    = P_CDREGIAO AND
                         CDPRODUTO   = P_CDPRODUTO AND
                         CDMARCA     = P_CDMARCA )));

       IF P_IDTPFOPGTCOL = NULL THEN
          DELETE FROM PZOPGTITMCOL
          WHERE
             CDFILIAL    = P_CDFILIAL    AND
             NRCOLEPRECO = P_NRCOLEPRECO AND
             CDFORNECED  = P_CDFORNECED  AND
             CDPRODUTO   = P_CDPRODUTO   AND
             CDMARCA     = P_CDMARCA     AND
             CDREGIAO    = P_CDREGIAO;

          UPDATE
             ITEMCOLE
          SET
             NRPARCPGTCOL = NULL,
             NRDIAPGFXCOL = NULL,
             IDUTDIAPGCOL = NULL
          WHERE
             NRCOLEPRECO = V_CODIGO     AND
             CDFORNECED  = P_CDFORNECED AND
             CDFILIAL    = P_CDFILIAL   AND
             CDREGIAO    = P_CDREGIAO   AND
             CDPRODUTO   = P_CDPRODUTO  AND
             CDMARCA     = P_CDMARCA;
       ELSE
          IF P_IDTPFOPGTCOL = 'V' THEN
             IF (P_NRDIAPGTCOL1 <> 0) AND (P_VRPERPGTCOL1 <> 0) THEN
                INSERT INTO PZOPGTITMCOL
                   (CDFILIAL, NRCOLEPRECO, CDFORNECED,   CDPRODUTO,
                    CDMARCA,  CDREGIAO,    NRDIASPGTCOL, VRPERCPGTCOL)
                VALUES
                   (P_CDFILIAL, V_CODIGO,   P_CDFORNECED,   P_CDPRODUTO,
                    P_CDMARCA,  P_CDREGIAO, P_NRDIAPGTCOL1, P_VRPERPGTCOL1);
             END IF;

             IF (P_NRDIAPGTCOL2 <> 0) AND (P_VRPERPGTCOL2 <> 0) THEN
                INSERT INTO PZOPGTITMCOL
                   (CDFILIAL, NRCOLEPRECO, CDFORNECED,   CDPRODUTO,
                    CDMARCA,  CDREGIAO,    NRDIASPGTCOL, VRPERCPGTCOL)
                VALUES
                   (P_CDFILIAL, V_CODIGO,   P_CDFORNECED,   P_CDPRODUTO,
                    P_CDMARCA,  P_CDREGIAO, P_NRDIAPGTCOL2, P_VRPERPGTCOL2);
             END IF;

             IF (P_NRDIAPGTCOL3 <> 0) AND (P_VRPERPGTCOL3 <> 0) THEN
                INSERT INTO PZOPGTITMCOL
                   (CDFILIAL, NRCOLEPRECO, CDFORNECED,   CDPRODUTO,
                    CDMARCA,  CDREGIAO,    NRDIASPGTCOL, VRPERCPGTCOL)
                VALUES
                   (P_CDFILIAL, V_CODIGO,   P_CDFORNECED,   P_CDPRODUTO,
                    P_CDMARCA,  P_CDREGIAO, P_NRDIAPGTCOL3, P_VRPERPGTCOL3);
             END IF;

             IF (P_NRDIAPGTCOL4 <> 0) AND (P_VRPERPGTCOL4 <> 0) THEN
                INSERT INTO PZOPGTITMCOL
                   (CDFILIAL, NRCOLEPRECO, CDFORNECED,   CDPRODUTO,
                    CDMARCA,  CDREGIAO,    NRDIASPGTCOL, VRPERCPGTCOL)
                VALUES
                   (P_CDFILIAL, V_CODIGO,   P_CDFORNECED,   P_CDPRODUTO,
                    P_CDMARCA,  P_CDREGIAO, P_NRDIAPGTCOL4, P_VRPERPGTCOL4);
             END IF;

             IF (P_NRDIAPGTCOL5 <> 0) AND (P_VRPERPGTCOL5 <> 0) THEN
                INSERT INTO PZOPGTITMCOL
                   (CDFILIAL, NRCOLEPRECO, CDFORNECED,   CDPRODUTO,
                    CDMARCA,  CDREGIAO,    NRDIASPGTCOL, VRPERCPGTCOL)
                VALUES
                   (P_CDFILIAL, V_CODIGO,   P_CDFORNECED,   P_CDPRODUTO,
                    P_CDMARCA,  P_CDREGIAO, P_NRDIAPGTCOL5, P_VRPERPGTCOL5);
             END IF;
          ELSE
             IF P_IDTPFOPGTCOL = 'F' THEN
                UPDATE ITEMCOLE
                SET    NRPARCPGTCOL = P_NRPARCPGTCOL,
                       NRDIAPGFXCOL = P_NRDIAPGFXCOL
                WHERE  NRCOLEPRECO  = V_CODIGO     AND
                       CDFORNECED   = P_CDFORNECED AND
                       CDFILIAL     = P_CDFILIAL   AND
                       CDREGIAO     = P_CDREGIAO   AND
                       CDPRODUTO    = P_CDPRODUTO  AND
                       CDMARCA      = P_CDMARCA;
             END IF;
          END IF;
       END IF;
   EXCEPTION
       WHEN DUP_VAL_ON_INDEX THEN BEGIN
          UPDATE
             ITEMCOLE
          SET
             VRPRECUNIITM = P_VALOR,
             DTINIVALITM  = P_DTINIVALITM,
             DTFINVALITM  = P_DTFINVALITM,
             NRPZOENTCOL  = P_NRPZOENTCOL,
             IDTIPFREITM  = P_IDTIPFREITM,
             CDTIPCOB     = P_CDTIPCOB,
             VRPERDESITM  = P_VRPERDESITM,
             CDFORMPGTO   = P_CDFORMPGTO,
             IDTPFOPGTCOL = P_IDTPFOPGTCOL,
             NRPARCPGTCOL = P_NRPARCPGTCOL,
             NRDIAPGFXCOL = P_NRDIAPGFXCOL,
             IDUTDIAPGCOL = P_IDUTDIAPGCOL
          WHERE
             NRCOLEPRECO = V_CODIGO     AND
             CDFORNECED  = P_CDFORNECED AND
             CDFILIAL    = P_CDFILIAL   AND
             CDREGIAO    = P_CDREGIAO   AND
             CDPRODUTO   = P_CDPRODUTO  AND
             CDMARCA     = P_CDMARCA;

          DELETE PZOPGTITMCOL
          WHERE  NRCOLEPRECO  = V_CODIGO     AND
                 CDFORNECED   = P_CDFORNECED AND
                 CDFILIAL     = P_CDFILIAL   AND
                 CDREGIAO     = P_CDREGIAO   AND
                 CDPRODUTO    = P_CDPRODUTO  AND
                 CDMARCA      = P_CDMARCA;

          IF P_IDTPFOPGTCOL = 'V' THEN

             UPDATE
                ITEMCOLE
             SET
                VRPRECUNIITM = P_VALOR,
                DTINIVALITM  = P_DTINIVALITM,
                DTFINVALITM  = P_DTINIVALITM,
                IDTPFOPGTCOL = P_IDTPFOPGTCOL
             WHERE
                NRCOLEPRECO = V_CODIGO     AND
                CDFORNECED  = P_CDFORNECED AND
                CDFILIAL    = P_CDFILIAL   AND
                CDREGIAO    = P_CDREGIAO   AND
                CDPRODUTO   = P_CDPRODUTO  AND
                CDMARCA     = P_CDMARCA;

             IF (P_NRDIAPGTCOL1 <> 0) AND (P_VRPERPGTCOL1 <> 0) THEN
                INSERT INTO PZOPGTITMCOL
                   (CDFILIAL, NRCOLEPRECO, CDFORNECED,   CDPRODUTO,
                    CDMARCA,  CDREGIAO,    NRDIASPGTCOL, VRPERCPGTCOL)
                VALUES
                   (P_CDFILIAL, V_CODIGO,   P_CDFORNECED,   P_CDPRODUTO,
                    P_CDMARCA,  P_CDREGIAO, P_NRDIAPGTCOL1, P_VRPERPGTCOL1);
             END IF;

             IF (P_NRDIAPGTCOL2 <> 0) AND (P_VRPERPGTCOL2 <> 0) THEN
                INSERT INTO PZOPGTITMCOL
                   (CDFILIAL, NRCOLEPRECO, CDFORNECED,   CDPRODUTO,
                    CDMARCA,  CDREGIAO,    NRDIASPGTCOL, VRPERCPGTCOL)
                VALUES
                   (P_CDFILIAL, V_CODIGO,   P_CDFORNECED,   P_CDPRODUTO,
                    P_CDMARCA,  P_CDREGIAO, P_NRDIAPGTCOL2, P_VRPERPGTCOL2);
             END IF;

             IF (P_NRDIAPGTCOL3 <> 0) AND (P_VRPERPGTCOL3 <> 0) THEN
                INSERT INTO PZOPGTITMCOL
                   (CDFILIAL, NRCOLEPRECO, CDFORNECED,   CDPRODUTO,
                    CDMARCA,  CDREGIAO,    NRDIASPGTCOL, VRPERCPGTCOL)
                VALUES
                   (P_CDFILIAL, V_CODIGO,   P_CDFORNECED,   P_CDPRODUTO,
                    P_CDMARCA,  P_CDREGIAO, P_NRDIAPGTCOL3, P_VRPERPGTCOL3);
             END IF;

             IF (P_NRDIAPGTCOL4 <> 0) AND (P_VRPERPGTCOL4 <> 0) THEN
                INSERT INTO PZOPGTITMCOL
                   (CDFILIAL, NRCOLEPRECO, CDFORNECED,   CDPRODUTO,
                    CDMARCA,  CDREGIAO,    NRDIASPGTCOL, VRPERCPGTCOL)
                VALUES
                   (P_CDFILIAL, V_CODIGO,   P_CDFORNECED,   P_CDPRODUTO,
                    P_CDMARCA,  P_CDREGIAO, P_NRDIAPGTCOL4, P_VRPERPGTCOL4);
             END IF;

             IF (P_NRDIAPGTCOL5 <> 0) AND (P_VRPERPGTCOL5 <> 0) THEN
                INSERT INTO PZOPGTITMCOL
                   (CDFILIAL, NRCOLEPRECO, CDFORNECED,   CDPRODUTO,
                    CDMARCA,  CDREGIAO,    NRDIASPGTCOL, VRPERCPGTCOL)
                VALUES
                   (P_CDFILIAL, V_CODIGO,   P_CDFORNECED,   P_CDPRODUTO,
                    P_CDMARCA,  P_CDREGIAO, P_NRDIAPGTCOL5, P_VRPERPGTCOL5);
             END IF;

             UPDATE ITEMCOLE
             SET    NRPARCPGTCOL = NULL,
                    NRDIAPGFXCOL = NULL,
                    IDUTDIAPGCOL = NULL
             WHERE  NRCOLEPRECO  = V_CODIGO     AND
                    CDFORNECED   = P_CDFORNECED AND
                    CDFILIAL     = P_CDFILIAL   AND
                    CDREGIAO     = P_CDREGIAO   AND
                    CDPRODUTO    = P_CDPRODUTO  AND
                    CDMARCA      = P_CDMARCA;

          ELSE
             IF P_IDTPFOPGTCOL = 'F' THEN
                UPDATE ITEMCOLE
                SET    CDFORMPGTO   = '',
                       NRPARCPGTCOL = P_NRPARCPGTCOL,
                       NRDIAPGFXCOL = P_NRDIAPGFXCOL,
                       IDTPFOPGTCOL = P_IDTPFOPGTCOL
                WHERE  NRCOLEPRECO  = V_CODIGO     AND
                       CDFORNECED   = P_CDFORNECED AND
                       CDFILIAL     = P_CDFILIAL   AND
                       CDREGIAO     = P_CDREGIAO   AND
                       CDPRODUTO    = P_CDPRODUTO  AND
                       CDMARCA      = P_CDMARCA;

                IF P_IDTPFOPGTCOL <> 'F' THEN
                   UPDATE ITEMCOLE
                   SET    NRPARCPGTCOL = NULL,
                          NRDIAPGFXCOL = NULL,
                          CDFORMPGTO   = NULL,
                          IDTPFOPGTCOL = NULL,
                          IDUTDIAPGCOL = NULL
                   WHERE  NRCOLEPRECO  = V_CODIGO     AND
                          CDFORNECED   = P_CDFORNECED AND
                          CDFILIAL     = P_CDFILIAL   AND
                          CDREGIAO     = P_CDREGIAO   AND
                          CDPRODUTO    = P_CDPRODUTO  AND
                          CDMARCA      = P_CDMARCA;
                END IF;
             END IF;
          END IF;
       END;
   END;

   SELECT
      CDARVPROD INTO V_CDARVPROD
   FROM
      PRODUTO
   WHERE
      CDPRODUTO = P_CDPRODUTO;

   /* Atualizando Imposto */

   SELECT
      COUNT(*) INTO COUNTEMIT
   FROM
      EMITENTEAF, PRODUTO PR
   WHERE
      EMITENTEAF.CDPRODUTO = PR.CDPRODUTO AND
      EMITENTEAF.CDFILIAL = P_CDFILIAL AND
      V_CDARVPROD LIKE PR.CDARVPROD || '%';

   IF COUNTEMIT > 0 THEN
      SELECT
         EMITENTEAF.CDEMPRESA INTO V_CDEMPRESA
      FROM
         EMITENTEAF, PRODUTO PR
      WHERE
         EMITENTEAF.CDPRODUTO = PR.CDPRODUTO AND
         EMITENTEAF.CDFILIAL = P_CDFILIAL AND
         V_CDARVPROD LIKE PR.CDARVPROD || '%';
   END IF;

   SELECT
      COUNT(*) INTO COUNTEMPR
   FROM
      EMPRESA,
      INSCRMUNICIP,
      INSCRESTAD
   WHERE
      EMPRESA.CDEMPRESA = V_CDEMPRESA            AND
      EMPRESA.CDEMPRESA = INSCRMUNICIP.CDEMPRESA AND
      EMPRESA.CDEMPRESA = INSCRESTAD.CDEMPRESA;

   IF COUNTEMPR > 0 THEN
      SELECT
         MIN(INSCRESTAD.CDINSCESTA) INTO V_INSCESTA
      FROM
         EMPRESA,
         INSCRMUNICIP,
         INSCRESTAD
      WHERE
         EMPRESA.CDEMPRESA = V_CDEMPRESA            AND
         EMPRESA.CDEMPRESA = INSCRMUNICIP.CDEMPRESA AND
         EMPRESA.CDEMPRESA = INSCRESTAD.CDEMPRESA
      GROUP BY
         EMPRESA.CDEMPRESA,
         EMPRESA.NRINSCESTA;
   END IF;

   IMPOSTO_ITEMCOL(V_CDEMPRESA, V_INSCESTA, P_CDFORNECED, P_CDFILIAL,
                   V_CODIGO, P_CDFORNECED, P_CDREGIAO, P_CDPRODUTO,
                   P_CDMARCA, TO_DATE(SYSDATE, 'DD/MM/YYYY'));

   DELETE FROM PZOPGTITMCOL
   WHERE  NRDIASPGTCOL = '0'           AND
          VRPERCPGTCOL = '0'           AND
          CDFILIAL     = P_CDFILIAL    AND
          NRCOLEPRECO  = V_CODIGO      AND
          CDFORNECED   = P_CDFORNECED  AND
          CDPRODUTO    = P_CDPRODUTO   AND
          CDMARCA      = P_CDMARCA     AND
          CDREGIAO     = P_CDREGIAO;

   DELETE FROM ITEMCOLE
   WHERE
      VRPRECUNIITM = '0' AND
      CDFILIAL     = P_CDFILIAL AND
      NRCOLEPRECO  = V_CODIGO AND
      CDFORNECED   = P_CDFORNECED AND
      CDREGIAO     = P_CDREGIAO AND
      CDPRODUTO    = P_CDPRODUTO AND
      CDMARCA      = P_CDMARCA;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('PED_COL','4.05.096'); END;
/

