/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_LEST                                                     */
/* Tabela : LOCALESTOQUE                                                      */
/*                                                                            */
/* Criao:                                                                   */
/* 04/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_LEST'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_LEST
GO

CREATE TRIGGER DTULTATU_LEST
ON LOCALESTOQUE
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'LOCALESTOQUE', CDFILIAL, 'CDFILIAL=' + CDFILIAL + ';' +
                                                 'CDALMOXARIFE=' + CDALMOXARIFE + ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE LOCALESTOQUE
      SET DTULTATULEST = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(LOCALESTOQUE.CDLOCALESTOQ,0) = ISNULL(INSERTED.CDLOCALESTOQ,0)) AND
            (ISNULL(LOCALESTOQUE.DSLOCALESTOQ,0) = ISNULL(INSERTED.DSLOCALESTOQ,0)) AND
            (ISNULL(LOCALESTOQUE.CDALMOXARIFE,0) = ISNULL(INSERTED.CDALMOXARIFE,0)) AND
            (ISNULL(LOCALESTOQUE.CDFILIAL,0)     = ISNULL(INSERTED.CDFILIAL,0));
   END;
END;
GO

